View Issue Details

IDProjectCategoryView StatusLast Update
0011574ScribusStory Editor / Text Framespublic2016-10-23 17:05
ReporterJLuc Assigned To 
PriorityurgentSeveritycrashReproducibilityhave not tried
Status confirmedResolutionopen 
Product Version1.5.0svn 
Target Version1.6 milestoneFixed in Version 
Summary0011574: Usability : Pasting text should not paste the paragraph style
DescriptionWhen copying some text, scribus also paste the origin paragraph style that overwrite pasted-place paragraphe styles and messes the layout.
This sometimes makes use of copy and paste particularly tricky : it requires many steps to achieve desired result, because the paragraph style has an effect on the whole paragraph, so the pasting action has layout-destructive side-effects.

Most of the time, at least when copied text does not include the end of paragraph, only the character styles have to be pasted.

Proposed behaviour :

- when the copied text doesnt include an end of paragraph, paste it with character styles ONLY (dont use/paste/overwrite paragraphe style).

- when the copied text includes an end of paragraphe style, paste the text including character AND the paragraph styles, which might lead to overwriting current paragraph style, as is now.




TagsMABs
PatchNo

Relationships

related to 0009812 new Font sizes get messed up on copy/paste 
has duplicate 0011216 closed Text layout bug collection 
related to 0003345 new Paste text without formatting 
related to 0010634 new Pasting text applies style to destination paragraph 

Activities

JLuc

2013-06-25 14:38

developer   ~0030358

See also 0003345: Paste text without formatting

JLuc

2014-05-17 20:46

developer  

copy'n'paste broken.ogv (116,641 bytes)

JLuc

2014-05-26 21:58

developer   ~0031936

i uploaded a screencast displaying the issue : out of the english lorem ipsum text, i want to copy the longdot (cadratin) glyph from one 'special style' paragraph and paste in in a 'normal paragraph style' paragraph. VDO shows how whole destination paragraph looses its style and becomes 'special style' too.

JLuc

2014-06-04 13:46

developer   ~0032001

2nd alinea reads : "when the copied text includes an end of paragraphe style, paste the text including character AND the paragraph styles, which might lead to overwriting current paragraph style, as is now."
Yes, but as for the part of the text that is AFTER the last "end of paragraph", it should be pasted *without* any paragraph styles, as in the first alinea : "with character styles ONLY (dont use/paste/overwrite paragraphe style)."

Dawoodalbadi

2015-11-03 06:42

reporter   ~0037169

hello
M.r Jluc it seems that you made conformation for your self ^_^
Is this issue have agreement to start working on the changes
??????????????????

ale

2015-11-03 08:33

manager   ~0037171

the issue is basically correct.
but it's not an easy hack.

it's probably not very hard to program, but it requires some thoughts on what has to be implemented.

for what i am concerned you can start working on this, but you should first make a proposal before working on real code.

here are a few "simple" edge cases:

- if noting is said, the formatting surrounding the cursor at the target place is applied to the pasted text.

- surrounding needs to be defined (character before, character after, both of them; what happens when one of both do not exist?)

- copy pasting a single word should not apply a paragraph style (except if it is a full paragraph).

- copy pasting a full paragraph in the middle of more text should probably by default use the original paragraph style.

- the local formatting and character styles that are applied to a selection bigger than what is copy-pasted should probably not be kept in the pasted text.

- the local formatting and character styles that are applied to a subset of the selection should by default be reproduced in the pasted text.

- we must define what happens if the subset starts or ends with the selection.

- the condition before might be different than the case where the subset start inside of the selection and ends outside of it (not at its boundaries)


- the local formatting and character that are applied to the exact same selection as the one copied might or not by default be copied (a decision must be taken)

- we should not over engineer the "keeping" of the paragraph formatting, since it's easy to reaply the paragraph style.

- we might want a new command "edit > paste without formatting"

- you need to define which is information is to be collected at the time you copy the text and which one at paste time.


i'm not compiling this list to scare you, but to help you define what exactly you need to implement.
you will need to digest it, and come up with a proposal.

you don't need to implement every aspect, but if you don't do so, you should probably write in the code what you are implementing and what not.

i did not have a look at the code, but i guess that you will need to add one or more new methods when implementing this ticket.
it would be nice to have a doxygen comment that describes what the code does (currently the behavior is basically undefined...)

ale

2015-11-03 09:51

manager   ~0037172

btw, concerning the self confirming: it could be that somebody on irc or in the mailing list confirmed the bug and jluc then confirmed it in here...

JLuc

2016-10-23 17:05

developer   ~0042180

yes that's it

Issue History

Date Modified Username Field Change
2013-06-05 09:50 JLuc New Issue
2013-06-25 14:38 JLuc Note Added: 0030358
2014-05-17 20:46 JLuc File Added: copy'n'paste broken.ogv
2014-05-26 21:58 JLuc Note Added: 0031936
2014-06-04 13:46 JLuc Note Added: 0032001
2014-10-11 15:41 Kunda Relationship added related to 0003345
2014-11-06 19:26 Kunda Tag Attached: MABs
2014-12-24 16:47 JLuc Patch => No
2014-12-24 16:47 JLuc Priority normal => urgent
2014-12-24 16:47 JLuc Severity feature => crash
2015-03-28 10:48 JLuc Relationship added has duplicate 0011216
2015-03-28 10:48 JLuc Status new => confirmed
2015-04-13 11:53 Kunda Target Version => 1.6 milestone
2015-06-27 22:39 Kunda Relationship added related to 0009812
2015-09-17 20:08 Kunda Category Story Editor / Text Frames => Story Ed/Txt Frames
2015-09-17 20:12 Kunda Category Story Ed/Txt Frames => Story Editor / Text Frames
2015-11-03 06:42 Dawoodalbadi Note Added: 0037169
2015-11-03 08:33 ale Note Added: 0037171
2015-11-03 09:51 ale Note Added: 0037172
2016-04-02 15:03 Kunda Relationship added related to 0010634
2016-10-23 17:05 JLuc Note Added: 0042180